/*
 *
 *   printer.h
 *
 *   Copyright (C) 2003, by the Grand River Dam Authority,
 *   All rights reserved.
 *
 *   Author: Matt Roberts
 *
 */


#ifndef __PRINTER_H
#define __PRINTER_H

#include <string>
#include <exception>

#include <my++/exception.h>

class Printer {
	public:
		typedef my::exception_template<Printer> exception;

	public:
		Printer (const std::string &dev);
		Printer (void);
		~Printer (void) throw();

		void open(const std::string &dev);
		void close(void) throw();
		ssize_t print (const signed char *s, size_t len);
		ssize_t print (const unsigned char *s, size_t len);
		ssize_t print (const std::string &s);

	private:
		int fd;
};

#endif
