/*
 *
 *   winbase.h
 *
 *   Copyright (C) 2003, by the Grand River Dam Authority,
 *   All rights reserved.
 *
 *   Author: Matt Roberts
 *
 */


#ifndef __WINBASE_H
#define __WINBASE_H

#include <string>

#include <curses.h>


/*
 *
 *
 *    class WinBase
 *
 *
 */

class WinBase {
	public:
		WinBase (void) { /* noop */ };
		virtual ~WinBase(void) { /* noop */ };

		virtual int write (const std::string &s) { return write((const unsigned char*)s.c_str(), s.size()); };
		virtual int write (const unsigned char *buffer, size_t count) = 0;

		virtual int put (int ch) = 0;

		virtual void refresh (void) = 0;

		virtual void test(void) { /* noop */ };

		virtual WinBase &operator = (WINDOW *w) = 0;
};


#endif /* __SGTERMWIN_H */
